<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1> Create Order </h1> </div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select id = "select-kich-co" class="form-control">
              <option> Chọn cỡ Combo (Combo size)</option>
              <option value="S"> Nhỏ</option>
              <option value="M"> Vừa</option>
              <option value="L"> Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option>Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input id = "inp-ma-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select id="select-loai-pizza" class = "form-control">            <!-- select chưa có id, các option chưa có value-->
              <option> Chọn loại pizza </option>
              <option value = "Seafood" > Hải sản</option>
              <option value = "Hawaii"> Ha wai </option>
              <option value = "Bacon" > Thịt hun khói </option>
            </select>
          </div>        
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input id = "inp-ho-va-ten" type="text" class="form-control" placeholder="Họ và tên"> 
          </div>
          <label for="" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-4">
            <input id="inp-email" type="email" class="form-control" placeholder="Email"> 
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input id="inp-so-dien-thoai" type="text" class="form-control" placeholder="Số điện thoại">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input id="inp-dia-chi" type="text" class="form-control" placeholder="Địa chỉ"> 
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea id="textarea-loi-nhan" class="form-control h-75" placeholder="Lời nhắn"></textarea>
        </div> 
        <div class="form-group">
          <button  class="btn btn-primary" onclick="onBtnCreateOrderCLick()">Create Order</button>
          <button  class="btn btn-secondary" id="btn-order-data" onclick="onBtnShowDataOrderClick()">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }

    //hàm xử lý khi nhấn nút create order
    function onBtnCreateOrderCLick(){
      "use strict"
      console.log("%c Nút Create order được click: ", "color: red");  
      var vOderObj = {
        kichCo: "",
        duongKinh: "", 
        suong: "", 
        salad: "", 
        loaiPizza: "", 
        idVoucher: "", 
        idLoaiNuocUong: "", 
        soLuongNuoc: "", 
        hoTen: "", 
        thanhTien: "", 
        email: "", 
        soDienThoai: "", 
        diaChi: "", 
        loiNhan: ""
      };

      //Bước 1: Thu Thập dữ liệu 
        thuThapDuLieu(vOderObj);
      //Bước 2: Kiểm tra dữ liệu 
        var vCheckOrder = kiemTraDuLieu(vOderObj);
        if(vCheckOrder){
          //Bước 3: gọi api send request 
          var vXmlHttp = new XMLHttpRequest();
          callAPIGetDataOrder(vXmlHttp, vOderObj);
          //bước 4: xử lý hiển thị sau khi request thành công 
          vXmlHttp.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS){
              handlerCreateData(vXmlHttp);
            }
          }
          
        }
      
    }

    //hàm xử lý khi nút show data được click
    function onBtnShowDataOrderClick(){
      "use strict"
      var vElementButtonShowOrder = document.getElementById("btn-order-data");
      var vGetOrderCode = vElementButtonShowOrder.dataset.ordercode;
      console.log("OrderCode là: " + vGetOrderCode);
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }

    //Hàm thu thập dữ liệu 
    function thuThapDuLieu(paramOrder){
      var vKichThuocSelect = document.getElementById("select-kich-co");
      var vMaVoucher = document.getElementById("inp-ma-voucher");
      var vHoVaTen = document.getElementById("inp-ho-va-ten");
      var vSoDienThoai = document.getElementById("inp-so-dien-thoai");
      var vLoiNhan = document.getElementById("textarea-loi-nhan");
      var vDoUong = document.getElementById("select-drink");
      var vLoaiPizza = document.getElementById("select-loai-pizza");
      var vEmail = document.getElementById("inp-email");
      var vDiaChi = document.getElementById("inp-dia-chi");

      paramOrder.kichCo = vKichThuocSelect.value;
      paramOrder.idVoucher = vMaVoucher.value.trim();
      paramOrder.hoTen = vHoVaTen.value.trim();
      paramOrder.soDienThoai = vSoDienThoai.value.trim();
      paramOrder.loiNhan = vLoiNhan.value.trim();
      paramOrder.idLoaiNuocUong = vDoUong.value;
      paramOrder.loaiPizza = vLoaiPizza.value;  
      paramOrder.email = vEmail.value.trim();
      paramOrder.diaChi = vDiaChi.value.trim();

      if(paramOrder.kichCo == "S"){
        paramOrder.duongKinh = 20;
        paramOrder.suong = 2;
        paramOrder.salad = 200;
        paramOrder.soLuongNuoc = 2;
        paramOrder.thanhTien = 150000;
      }
      else if(paramOrder.kichCo == "M"){
        paramOrder.duongKinh = 24;
        paramOrder.suong = 4;
        paramOrder.salad = 300;
        paramOrder.soLuongNuoc = 3;
        paramOrder.thanhTien = 200000;
      }
      else if(paramOrder.kichCo == "L"){
        paramOrder.duongKinh = 30;
        paramOrder.suong = 8;
        paramOrder.salad = 500;
        paramOrder.soLuongNuoc = 4;
        paramOrder.thanhTien = 250000;
      }
    }

    //hàm kiểm tra dữ liệu 
    function kiemTraDuLieu(paramOrder){
      if(paramOrder.kichCo == "Chọn cỡ Combo (Combo size)"){
        alert("Vui lòng chọn kích cỡ của pizza!");
        return false;
      }
      if(paramOrder.idVoucher == ""){
        alert("Vui lòng nhập mã Voucher!");
        return false;
      }
      if(paramOrder.hoTen == ""){
        alert("Vui lòng nhập Họ và Tên!");
        return false;
      }
      if(paramOrder.soDienThoai == ""){
        alert("Vui lòng nhập số điện thoại!");
        return false;
      }
      if(paramOrder.idLoaiNuocUong == "Chọn đồ uống"){
        alert("Vui lòng chọn đồ uống!");
        return false;
      }
      if(paramOrder.loaiPizza == "Chọn loại pizza"){
        alert("Vui lòng chọn loại pizza!");
        return false;
      }
      if(paramOrder.email == ""){
        alert("Vui lòng nhập Email!");
        return false;
      }
      if(validateEmail(paramOrder.email) == false){
        return false;
      }
      if(paramOrder.diaChi == ""){
        alert("Vui lòng nhập địa chỉ!");
        return false;
      }
      return true;
    }

    //hàm kiểm tra email
    function validateEmail(paramEmail){
      var vValidateEmail = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
      if (!vValidateEmail.test(paramEmail)) {
      alert('Hãy nhập địa chỉ Email hợp lệ!');
      email.focus;
      return false;
      }
      else {
        return true;
      }
    }

    //hàm gọi API send request
    function callAPIGetDataOrder(paramXmlHttp, paramOrder){
      "use strict"
      paramXmlHttp.open("POST", gBASE_URL, true);
      paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramOrder));
      console.log(paramOrder);
    }

    //hàm xử lý hiển thị khi response thành công 
    function handlerCreateData(paramXmlHttp){
      "use strict"
      var vCreateOrder = paramXmlHttp.responseText;
      console.log(vCreateOrder);

      //parsing dữ liệu thành object
      var vOrderObj = JSON.parse(paramXmlHttp.responseText);
      //tạo biến để chứa ordercode của object
      var vOrderCode = vOrderObj.orderCode;

      //Ghi được odercode nhận vào Dataset của nút Show Order Data in new Form
      var vElementButtonShowOrder = document.getElementById("btn-order-data");
      vElementButtonShowOrder.setAttribute("data-ordercode", vOrderCode);

    }
  </script>


</body>

</html>